# encoding: utf-8
# WARNING! Do not edit! https://waf.io/book/index.html#_obtaining_the_waf_file

import re
from waflib.Task import Task
from waflib.TaskGen import extension
class protoc(Task):
	run_str='${PROTOC} ${PROTOC_FLAGS} ${PROTOC_ST:INCPATHS} ${SRC[0].abspath()}'
	color='BLUE'
	ext_out=['.h','pb.cc']
	def scan(self):
		node=self.inputs[0]
		nodes=[]
		names=[]
		seen=[]
		if not node:
			return(nodes,names)
		def parse_node(node):
			if node in seen:
				return
			seen.append(node)
			code=node.read().splitlines()
			for line in code:
				m=re.search(r'^import\s+"(.*)";.*(//)?.*',line)
				if m:
					dep=m.groups()[0]
					for incpath in self.env.INCPATHS:
						found=incpath.find_resource(dep)
						if found:
							nodes.append(found)
							parse_node(found)
						else:
							names.append(dep)
		parse_node(node)
		return(nodes,names)
@extension('.proto')
def process_protoc(self,node):
	cpp_node=node.change_ext('.pb.cc')
	hpp_node=node.change_ext('.pb.h')
	self.create_task('protoc',node,[cpp_node,hpp_node])
	self.source.append(cpp_node)
	if'cxx'in self.features and not self.env.PROTOC_FLAGS:
		self.env.PROTOC_FLAGS='--cpp_out=%s'%node.parent.get_bld().bldpath()
	use=getattr(self,'use','')
	if not'PROTOBUF'in use:
		self.use=self.to_list(use)+['PROTOBUF']
def configure(conf):
	conf.check_cfg(package="protobuf",uselib_store="PROTOBUF",args=['--cflags','--libs'])
	conf.find_program('protoc',var='PROTOC')
	conf.env.PROTOC_ST='-I%s'
