# encoding: utf-8
# WARNING! Do not edit! https://waf.io/book/index.html#_obtaining_the_waf_file

import os
from waflib import Task,TaskGen,Errors
def _process_use_rec(self,name):
	if name in self.pytest_use_not or name in self.pytest_use_seen:
		return
	try:
		tg=self.bld.get_tgen_by_name(name)
	except Errors.WafError:
		self.pytest_use_not.add(name)
		return
	self.pytest_use_seen.append(name)
	tg.post()
	for n in self.to_list(getattr(tg,'use',[])):
		_process_use_rec(self,n)
@TaskGen.feature('pytest')
@TaskGen.after_method('process_source')
def pytest_process_use(self):
	self.pytest_use_not=set()
	self.pytest_use_seen=[]
	self.pytest_paths=set()
	self.pytest_dep_nodes=[]
	names=self.to_list(getattr(self,'use',[]))
	for name in names:
		_process_use_rec(self,name)
	for name in self.pytest_use_seen:
		tg=self.bld.get_tgen_by_name(name)
		if'py'in tg.features:
			self.pytest_dep_nodes.extend([s for s in tg.source if s.suffix()=='.py'])
			pypath=getattr(tg,'install_from',None)
			if not pypath:
				pypath=tg.path
			self.pytest_paths.add(pypath.abspath())
		if getattr(tg,'link_task',None):
			self.pytest_dep_nodes.extend(tg.link_task.outputs)
@TaskGen.feature('pytest')
@TaskGen.after_method('pytest_process_use')
def make_pytest(self):
	nodes=self.to_nodes(self.pytest_source)
	tsk=self.create_task('utest',nodes)
	tsk.dep_nodes.extend(self.pytest_dep_nodes)
	if getattr(self,'ut_str',None):
		self.ut_run,lst=Task.compile_fun(self.ut_str,shell=getattr(self,'ut_shell',False))
		tsk.vars=lst+tsk.vars
	if getattr(self,'ut_cwd',None):
		if isinstance(self.ut_cwd,str):
			if os.path.isabs(self.ut_cwd):
				self.ut_cwd=self.bld.root.make_node(self.ut_cwd)
			else:
				self.ut_cwd=self.path.make_node(self.ut_cwd)
	else:
		if tsk.inputs:
			self.ut_cwd=tsk.inputs[0].parent
		else:
			raise Errors.WafError("no valid input files for pytest task, check pytest_source value")
	if not self.ut_cwd.exists():
		self.ut_cwd.mkdir()
	self.ut_env=dict(os.environ)
	self.ut_env['PYTHONPATH']=os.pathsep.join(self.pytest_paths)+self.ut_env.get('PYTHONPATH','')
